package net.action;

import net.bo.Application;
import net.bo.SessionApp;

/**
 * Affiche le contenu de la variable passée en argument
 * <b>me</b> correspond à l'utilisateur actif
 * users à la collection des utilisateurs
 * groups à la collection des groupes
 * toute autre valeur est interprétée comme le login d'un utilisateur à afficher, ou le nom d'un groupe
 * @author jc
 *
 */
public class CmdPrint extends Commande {

	public CmdPrint(SessionApp sessionApp) {
		super(sessionApp);
		argsCount=1;
	}

	public CmdPrint() {
		argsCount=1;
	}

	@Override
	public int run() {
		Application application=getApplication();
		switch (args.get(0)) {
		case "me":
			application.print(sessionApp.getActiveUser());
			break;
		case "users":
			application.print(application.getLesUtilisateurs());
			break;
		case "groups":
			application.print(application.getLesGroupes());
			break;
		default:
			if(application.getLesUtilisateurs().containsKey(args.get(0)))
				application.print(application.getLesUtilisateurs().get(args.get(0)));
			else if(application.getLesGroupes().containsKey(args.get(0)))
				application.print(application.getLesGroupes().get(args.get(0)));
			else
				application.print("Variable inconnue : "+args.get(0));
			break;
		}
		return 0;
	}

}
