package net.action;

import net.bo.Application;
import net.bo.Groupe;
import net.bo.SessionApp;
import net.bo.Utilisateur;

/**
 * Définit le groupe de l'utilisateur actif
 * La commande n'est autorisée que pour un superAdmin
 * @author jc
 *
 */
public class CmdSetGroup extends Commande {

	public CmdSetGroup(SessionApp sessionApp) {
		super(sessionApp);
		argsCount=1;
		isSuperAdmin=true;
	}

	public CmdSetGroup() {
		this(null);
	}

	@Override
	public int run() {
		Application application=getApplication();
		Utilisateur user;
		Groupe group;
		if(args.size()==2){
			user=application.getLesUtilisateurs().get(args.get(0));
			group=application.getLesGroupes().get(args.get(1));
			if(user!=null){
				if(group!=null)
					user.addToGroup(group);
				else
					application.print("Groupe "+args.get(1)+" inconnu");
			}else
				application.print("Utilisateur "+args.get(0)+" inconnu");
		}else
		{
			group=application.getLesGroupes().get(args.get(0));
			if(group!=null)
				sessionApp.getActiveUser().addToGroup(group);
			else
				application.print("Groupe "+args.get(0)+" inconnu");
		}
		return 0;
	}

}
