package net.technics;

import java.util.Calendar;
import java.util.Date;

/**
 * Permet d'effectuer un verouillage identifié par une clé id, durant au maximum un temps ttl
 * @author jc
 *
 */
public class Lock {
	private String id;
	private String userId;
	private Date time;
	
	public Lock(String id) {
		super();
		this.id = id;
		Calendar cal = Calendar.getInstance();
    	time=cal.getTime();
	}
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public Date getTime() {
		return time;
	}
	
	public boolean canUnlock(int ttl){
		Calendar cal = Calendar.getInstance();
    	Date newTime=cal.getTime();	
    	int diff=(int) ((newTime.getTime()-time.getTime())/1000);
		return diff>ttl;
	}
	
	@Override
	public boolean equals(Object obj) {
		boolean result=false;
		if(obj instanceof Lock)
			result=((Lock)obj).getId().equals(id);
		return result;
	}
	
	public String getUserId() {
		return userId;
	}
	
	public void setUserId(String userId) {
		this.userId = userId;
	}
	
	@Override
	public int hashCode() {
		return id.hashCode();
	}
	
	public void setTime(Date time) {
		this.time = time;
	}
}
