package net.technics;

import java.util.ArrayList;
import java.util.List;
/**
 * Représente une liste de verrous
 * @author jc
 *
 */
public class LockList {
	private List<Lock> locks;
	private int ttl;
	public final static int defaultTTL=1200;

	public LockList(int ttl) {
		super();
		this.ttl = ttl;
		locks=new ArrayList<>();
		System.out.println("LockList créée <<ttl>> : "+ttl);
	}
	
	public LockList() {
		this(defaultTTL);
	}
	
	public int getTtl() {
		return ttl;
	}

	public void setTtl(int ttl) {
		this.ttl = ttl;
	}

	public List<Lock> getLocks() {
		return locks;
	}
	
	public synchronized boolean  lock(String key){
		Lock tmpLock=new Lock(key);
		int pos=locks.indexOf(tmpLock);
		if(pos!=-1){
			Lock theLock=locks.get(pos);
			if(theLock.canUnlock(ttl)){
				remove(pos, key);
				locks.add(tmpLock);
				return true;
			}else{
				System.out.println("Impossible de verrouiller l'objet <<"+key+">> : il est actuellement verrouillé");
				return false;
			}
		}else{
			System.out.println("Verrou posé sur <<"+key+">>");
			locks.add(tmpLock);
			return true;
		}
	}
	
	private void remove(int index,String key){
		System.out.println("L'objet <<"+key+">> a été déverrouillé");
		locks.remove(index);
	}
	
	public synchronized boolean unlock(String key){
		Lock tmpLock=new Lock(key);
		int pos=locks.indexOf(tmpLock);
		if(pos!=-1){
			remove(pos, key);
			return true;
		}
		return false;
	}
	
	public boolean contains(Lock aLock){
		return locks.contains(aLock);
	}
	
	public Lock get(String key){
		Lock tmpLock=new Lock(key);
		int pos=locks.indexOf(tmpLock);
		if(pos!=-1){
			return locks.get(pos);
		}
		return null;
	}
	
	public void clear(){
		locks.clear();
		System.out.println("Liste de verrous vidée");
	}
	
}
