package web.technics;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspWriter;

import web.gui.HtmlView;

import net.bo.SessionApp;

/**
 * Passerelle entre SessionApp (mode console) et mode Web
 * @author jc
 *
 */
public class Utils {
	/**
	 * Retourne la session utilisateur active à partir de la session Http
	 * @param session Session Http
	 * @return session active
	 */
	public static SessionApp getSessionApp(HttpSession session){
		SessionApp result= (SessionApp)session.getAttribute("sessionApp");
		if(result==null){
			result=new SessionApp();
			session.setAttribute("sessionApp", result);
		}
		return result;
	}
	
	/**
	 * Retourne la session utilisateur active à partir de la requête Http
	 * @param request Requête Http
	 * @return
	 */
	public static SessionApp getSessionApp(HttpServletRequest request){
		return getSessionApp(request.getSession());
	}
	/**
	 * Permet de définir le flux de sortie utilisé par l'application
	 * @param sessionApp Session utilisateur
	 * @param out Flux de sortie
	 */
	public static void setOut(SessionApp sessionApp,PrintWriter out){
		sessionApp.getApplication().setView(new HtmlView(out));
	}
	/**
	 * Permet de définir le flux de sortie utilisé par l'application
	 * @param sessionApp Session utilisateur
	 * @param out Flux de sortie
	 */
	public static void setOut(SessionApp sessionApp,JspWriter out){
		sessionApp.getApplication().setView(new HtmlView(out));
	}
}
