package web.technics;

import javax.servlet.http.HttpServletRequest;

public class WRequest {
	/**
	 * Retourne le paramètre de nom parameterName de la requête
	 * @param request requête HTTP
	 * @param parameterName nom du paramètre
	 * @return
	 */
	public static String GET(HttpServletRequest request,String parameterName){
		return request.getParameter(parameterName);
	}
	/**
	 * Retourne le paramètre de nom parameterName de la requête et retourne defaultValue si le paramètre n'est pas trouvé
	 * @param request requête HTTP
	 * @param parameterName nom du paramètre
	 * @param defaultValue valeur par défault
	 * @return paramètre de la requête
	 */
	@SuppressWarnings("unchecked")
	public static <T> T  GET(HttpServletRequest request,String parameterName,T defaultValue){
		T result;
		String p=request.getParameter(parameterName);
		if(p==null)
			result= defaultValue;
		else{
			try{
				result=(T)request.getParameter(parameterName);
			}catch(Exception e){
				result= defaultValue;
			}
		}
		return result;
	}
	/**
	 * Retourne l'attribut de nom attributeName de la requête
	 * @param request requête HTTP
	 * @param attributeName nom de l'attribut
	 * @return
	 */
	public static Object GETAttr(HttpServletRequest request,String attributeName){
		return request.getAttribute(attributeName);
	}
	/**
	 * Retourne l'attribut de nom attributeName de la requête et retourne defaultValue si l'attribut n'est pas trouvé
	 * @param request requête HTTP
	 * @param attributeName nom de l'attribut
	 * @param defaultValue valeur par défault
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static <T> T  GETAttr(HttpServletRequest request,String attributeName,T defaultValue){
		T result=(T)request.getAttribute(attributeName);
		if(result==null)
			result= defaultValue;
		return result;
	}
}
